# Настройки поля

### Шаблоны
Разные настройки для шаблонов сделаны для того чтобы значение могло отображатся от контекста где оно вызвано. <br/>
Например, у нас есть блог. Есть страница общая блога и отдельной записи. Нам надо чтобы при общей блога поле отображалось одним видом, а на странице отдельной записи по другому. Например, у нас есть слайдшоу, нам надо чтобы на общей блоге отображался только одна картинка, а на странице записи полностью весь слайдшоу, мы делаем два шаблона и в одном выгружаем первую картинку из массива, а во втором выводим полный массив картинок в обертке для слайдшоу.


### Шаблон по умолчанию
Это шаблон по умолчанию и резервный шаблон если не сработали шаблоны для категории и элемента.


### Шаблон для категории
Применяется для контекстов вызова:
- com_content.category 
- com_content.categories
- com_users.users
- com_contact.categories
- com_tags.tag


### Шаблон для элемента
Применяется для контекстов вызова:
- com_content.article
- com_users.user
- com_contact.contact


### Контекст применения шаблонов
По умолчанию контекст вызова шаблона выбирается из REQUEST параметров, которые Joomla назначает, это option и view. <br/>
Вы можете повлиять на контекст вызова. Для этого вам еще раз надо загрузить поля от хелпера и назначить свойство context_local и нужный контекст.

Пример:
```php
$fields = [];
$item->context_local = 'com_content.category';
$jcfields = FieldsHelper::getFields('com_content.article', $item, true);

foreach ($jcfields as $field)
{
    $fields[$field->name] = $field;
}

echo $fields['my_field_name']->value;
```

### Поле JForm
Здесь вы выбираете нужное вам поле JForm. Вы можете загрузить любые поля указав в [настройках плагина дополнительные](https://github.com/Delo-Design/radicaluniversalfield/blob/master/docs/loadfields.md) пути для поиска полей. <br/>
Если выберите list или radio, то вам покажется ввод значений для списка.<br/>
Если выберите subform, то вам покажется ввод полей для subform.


### Дополнительные атрибуты
Здесь вы можете ввести все атрибуты, которые вам надо для поля. <br/>
Например, для subform требуется указание атрибута layout и если вам надо создавать новые элементы в subform, то надо проставить атрибут multiple, который будет равен true. <br/>
Подробнее можете прочитать здесь о subform: [https://docs.joomla.org/Subform_form_field_type](https://docs.joomla.org/Subform_form_field_type) <br/>
Все атрибуты стандартных полей Joomla! вы можете прочитать тут: [https://docs.joomla.org/Standard_form_field_types](https://docs.joomla.org/Standard_form_field_types)


### Адаптирование не работающих полей к subform
Не все поля адаптированы к subform, так как там есть кастомное событие для jQuery и не все поля прописан дополнительный код на запуск своих скриптов на новые элементы сабформы.<br/>
Но эту проблему можно исправить. Каким образом? Сейчас subform меняет только name у input. Но надо менять и id что идет в шаблонах. И второе, надо просто запускать с помощью javascript событие окончания загрузки страницы на конкретно строчку subform новой. <br/>
Сейчас реализовано только запуск этого события, замены дополнительной еще не сделано.